package fr.dgac.ivy;

/**
 * this interface specifies the methods of an ApplicationListener
 *
 * @author	Franois-Rgis Colin
 * @author	Yannick Jestin
 * @author	<a href="http://www.tls.cena.fr/products/ivy/">http://www.tls.cena.fr/products/ivy/</a>
 *
 * The ApplicatinListenr  for receiving application level events on the Ivy
 * bus: connexion, disconnexion, direct messages or requests to quit. 
 */

public interface IvyApplicationListener extends java.util.EventListener {
  /**
   * invoked when a Ivy Client has joined the bus
   * @param client the peer
   */
  public abstract void connect(IvyClient client);
  /**
   * invoked when a Ivy Client has left the bus
   * @param client the peer
   */
  public abstract void disconnect(IvyClient client);
  /**
   * invoked when a peer request us to leave the bus
   * @param client the peer
   */
  public abstract void die(IvyClient client, int id);
  /**
   * invoked when a peer sends us a direct message
   * @param client the peer
   * @param id 
   * @param msgarg the message itself
   * this is not yet implemented in java. I believe it has no real use :)
   */
  public abstract void directMessage( IvyClient client, int id,String msgarg );
}
